--
-- Select own activities
--
SELECT
    A.ID
   ,A.NAME
   ,A.DESCRIPTION
   ,A.REGISTERED
   ,R.COLOR_ID
   ,C.COLOR AS COLOR_VALUE
   ,C.NAME  AS COLOR_NAME
   ,A.IS_SEND_MAIL
   ,F.TOKEN AS FEED_TOKEN
FROM
    activities A
    INNER JOIN activity_members   M ON A.ID = M.ACTIVITY_ID
                                   AND M.DEL_FLAG = '0'
    INNER JOIN activity_relations R ON A.ID = R.ACTIVITY_ID
                                   AND R.USER_ID = /*userId*/1
    INNER JOIN activity_colors    C ON R.COLOR_ID = C.ID
    LEFT JOIN  feed_tokens        F ON A.ID = F.ACTIVITY_ID
                                   AND F.USER_ID = /*userId*/1
                                   AND F.DEL_FLAG = '0'
WHERE
    M.USER_ID = /*userId*/1
AND A.DEL_FLAG = '0'
ORDER BY
    A.ID