--
-- find by user id for timeline.
--
SELECT 
    A.ID
   ,A.STATUS
   ,R.BASIC_ID
   ,M.ACTIVITY_ID
   ,S.COLOR_ID
   ,C.COLOR AS COLOR_VALUE
   ,B.BODY
   ,A.POSTED_USER_ID
   ,A.REGISTERED 
FROM 
    meeting_agendas A
    INNER JOIN (
        SELECT MA.ID
        FROM meeting_agendas MA
        WHERE
            MA.POSTED_USER_ID = /*userId*/1
        AND MA.REGISTERED BETWEEN /*startDate*/'20080501000000'
                              AND /*endDate*/'20080531999999'
        AND MA.DEL_FLAG = '0'
        GROUP BY
            MA.ID
           ,SUBSTR(MA.REGISTERED,1,8)
    ) A2 ON A.ID = A2.ID
    INNER JOIN meeting_agenda_bodies B ON A.ID = B.AGENDA_ID
    INNER JOIN meeting_relations     R ON A.ID = R.AGENDA_ID
    INNER JOIN meeting_basics        M ON R.BASIC_ID = M.ID
    INNER JOIN activity_relations    S ON S.ACTIVITY_ID = M.ACTIVITY_ID
                                      AND S.USER_ID = /*userId*/1
    INNER JOIN activity_colors       C ON S.COLOR_ID = C.ID 
ORDER BY 
    A.ID