--
-- task group relations.get tasks by task group id.
--
SELECT DISTINCT
    R.task_group_id
   ,G.name
   ,G.description 
   ,G.start_date
   ,G.deadline
   ,G.registered
   ,G.modified
   ,G.user_id
   ,A.activity_id
   ,V.name AS activity_name
   ,AC.color AS activity_color
   ,S.id
   ,S.task_id
   ,S.classification_id
   ,S.status_id
   ,T.title
   ,T.dead_line as task_dead_line
FROM
    task_group_relations R
    INNER JOIN task_groups G           ON R.task_group_id = G.id
                                      AND G.del_flag = '0'
    INNER JOIN task_group_activities A ON R.task_group_id = A.task_group_id
    INNER JOIN activities            V ON A.activity_id = V.id
    INNER JOIN activity_relations   AR ON A.activity_id = AR.activity_id
                                      AND AR.user_id = /*userId*/1
    INNER JOIN activity_colors      AC ON AR.color_id = AC.id
    INNER JOIN (
        SELECT A1.id
        FROM activities A1
            INNER JOIN activity_members A2 ON A1.id = A2.activity_id
        WHERE
            A2.user_id = /*userId*/1
    ) A3 ON A.activity_id = A3.id
    INNER JOIN task_relations S        ON R.task_id = S.task_id
    INNER JOIN tasks T                 ON R.task_id = T.id
WHERE
    R.task_group_id = /*taskGroupId*/1
ORDER BY
    S.classification_id
   ,S.status_id
   ,T.dead_line
   ,A.activity_id
   ,S.id